diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -1834,76 +1797,77 @@
       lprintf_nl "ERROR: complete block in permute_and_return %d\n" b;
       assert false
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         LinearStrategy.select_block (internal)            *)
-(*                                                                       *)
-(*************************************************************************)
+(** find a block in up_complete_blocks that's not already
+    CompleteBlock or VerifiedBlock.
+    If none can be found, do the same with up_partial_blocks.
+    If none can be found still, raise Not_found exception 
+    
+    up_ncomplete and up_npartial are used as in the same way as in
+    permute_and_return, but no element is ever permuted.
+
+    Since set_uploader_intervals puts the blocks with the lowest
+    offsets at the end of up_complete_blocks and up_partial_blocks,
+    this also selects the blocks in increasing offsets order.
+*)
 
-module LinearStrategy = struct
-    let select_block  up =
-      let rec iter_complete up =
-        let n = up.up_ncomplete in
-        if n = 0 then iter_partial up
-        else
-        let b = up.up_complete_blocks.(n-1) in
-        up.up_ncomplete <- n-1;
-        let t = up.up_t in
-        let s = t.t_s in
-        match s.s_blocks.(b) with
-          CompleteBlock | VerifiedBlock ->
-            iter_complete up
-        | PartialBlock b ->
-            b, b.block_begin, b.block_end
-        | EmptyBlock ->
-            let b = new_block s b in
-            b, b.block_begin, b.block_end
-
-      and iter_partial up =
-        let n = up.up_npartial in
-        if n = 0 then raise Not_found;
-        let b, block_begin, block_end = up.up_partial_blocks.(n-1) in
-        let t = up.up_t in
-        let s = t.t_s in
-        match s.s_blocks.(b) with
-          CompleteBlock | VerifiedBlock ->
-            iter_partial up
-        | PartialBlock b ->
-            b, block_begin, block_end
-        | EmptyBlock ->
-            let b = new_block s b in
-            b, block_begin, block_end
-      in
-      iter_complete up
-  end
+let linear_select_block up =
+  let rec iter_partial up =
+    let n = up.up_npartial in
+    if n = 0 then raise Not_found;
+    let b, block_begin, block_end = up.up_partial_blocks.(n-1) in
+    up.up_npartial <- n-1;
+    let t = up.up_t in
+    let s = t.t_s in
+    (* priority bitmap <> 0 here ? *)
+    match s.s_blocks.(b) with
+    | CompleteBlock | VerifiedBlock ->
+        iter_partial up
+    | PartialBlock b ->
+        b, block_begin, block_end
+    | EmptyBlock ->
+        let b = new_block s b in
+        b, block_begin, block_end in
+  let rec iter_complete up =
+    let n = up.up_ncomplete in
+    if n = 0 then iter_partial up
+    else
+      let b = up.up_complete_blocks.(n-1) in
+      up.up_ncomplete <- n-1;
+      let t = up.up_t in
+      let s = t.t_s in
+      (* priority bitmap <> 0 here ? *)
+      match s.s_blocks.(b) with
+      | CompleteBlock | VerifiedBlock ->
+          iter_complete up
+      | PartialBlock b ->
+          b, b.block_begin, b.block_end
+      | EmptyBlock ->
+          let b = new_block s b in
+          b, b.block_begin, b.block_end
+  in
+  iter_complete up
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         should_download_block (internal)              *)
-(*                                                                       *)
-(*************************************************************************)
+(** Check whether block [n] of swarmer [s] is not completed yet,
+    calling chunk verification first if block still need verification *)
 
 let should_download_block s n =
 (*  lprintf "should_download_block %d\n" n; *)
   let result =
     match s.s_verified_bitmap.[n] with
-      '2' ->
-        begin
-          match s.s_networks with
-            [] -> assert false
-          | t :: _ when t.t_primary ->
-              begin
-                try
-                  let n = t.t_chunk_of_block.(n) in
-                  if t.t_converted_verified_bitmap.[n] = '2' then
-                    verify_chunk t n
-                with VerifierNotReady -> ()
-              end
-          | _ -> ()
-        end;
-        s.s_verified_bitmap.[n] < '2'
     | '0' | '1' -> true
-    | _ -> false
+    | '2' ->
+        (match s.s_networks with
+         | t :: _ ->
+	     assert(t.t_primary);
+             (try
+               let n = t.t_chunk_of_block.(n) in
+               if t.t_converted_verified_bitmap.[n] = '2' then
+                 verify_chunk t n
+             with VerifierNotReady -> ());
+	 | [] -> assert false);
+        s.s_verified_bitmap.[n] < '2'
+    | '3' -> false
+    | _ -> assert false
   in
 (*  if result then
     lprintf "should_download_block %d\n" n; *)
@@ -1915,264 +1879,279 @@
 (*                                                                       *)
 (*************************************************************************)
 
-exception BlockFound of int
+(* Would it be faster not to build those records, and use functions of
+   the block number ? *)
 
-let random_int max =
-  let x = Random.int max in
-  if debug_all then lprintf_nl "(Random %d -> %d)" max x;
-  x
+type choice = {
+  choice_num : int;
+  choice_user_priority : int;
+  choice_nuploaders : int;
+  choice_remaining : int64;
+  choice_remaining_per_uploader : int64;
+  choice_other_complete : int Lazy.t; (* ...blocks in the same chunk *)
+  choice_availability : int;
+}
+
+let dummy_choice = {
+  choice_num = 0;
+  choice_user_priority = 0;
+  choice_nuploaders = 0;
+  choice_remaining = 0L;
+  choice_remaining_per_uploader = 0L;
+  choice_other_complete = lazy 0;
+  choice_availability = 0
+}
+
+(* based on Array.fold_left code *)
+let array_fold_lefti f x a =
+  let r = ref x in
+  for i = 0 to Array.length a - 1 do
+    r := f !r i (Array.unsafe_get a i)
+  done;
+  !r
+
+let subarray_fold_lefti f x a firstidx lastidx =
+  let len = Array.length a in
+  assert(firstidx >= 0 && firstidx < len);
+  assert(lastidx >= 0 && lastidx < len);
+  let r = ref x in
+  for i = firstidx to lastidx do
+    r := f !r i (Array.unsafe_get a i)
+  done;
+  !r
+
+(* DEBUGGING *)
+let delta_needed = ref 0
+let delta_undecided = ref 0
 
 let select_block up =
+(* DEBUGGING *)
+  let compare_choices_saturation = ref 0 in
+  let compare_choices_priority = ref 0 in
+  let compare_choices_rarity = ref 0 in
+  let compare_choices_completion = ref 0 in
+  let compare_choices_siblings = ref 0 in
+  let compare_choices_failure = ref 0 in
+
   let t = up.up_t in
   let s = t.t_s in
   try
     match s.s_strategy with
-      LinearStrategy ->
-        LinearStrategy.select_block up
+    | LinearStrategy ->
+        linear_select_block up
     | _ ->
         if up.up_ncomplete = 0 && up.up_npartial = 0 then raise Not_found;
 
-(**************
-
-This strategy sucks. It has to be improved.
-Important:
-1) never give a block to 2 clients if another one has 0 client.
-2) try to complete partial blocks as soon as possible.
-3) comfigure the chooser depending on the network (maybe BT might
-better work at the beginning if the first incomplete blocks are offered
-    to several clients.
-
-***************)
-
-
-
-        if up.up_ncomplete > 1 then begin
-(*          let debug_all = true in *)
-            try
-
-              let rec iter_max_uploaders max_nuploaders =
-                let t = up.up_t in
-                let nblocks = Array.length s.s_blocks in
-
-(*************   Try to download the movie index and the first minute to
-   allow preview of the file as soon as possible *)
-
-                if debug_all then lprintf_nl "{First}";
-
-                let download_first n b =
-(*                lprintf "download_first %d\n" n; *)
-                  if
-                    up.up_complete_blocks.(n) = b &&
-                    s.s_nuploading.(b) < max_nuploaders &&
-                    should_download_block s b then
-                    raise (BlockFound n)
-                in
-
-(*              lprintf "up_complete_blocks: %d\n"
-                (Array.length up.up_complete_blocks); *)
-
-(* This must be the position of the last block of the file *)
-                download_first 0 (nblocks-1);
-
-(* This can be the position of the first block of the file *)
-                download_first (up.up_ncomplete-1) 0;
-
-(* This can be the position of the first block of the file *)
-                download_first 0 0;
-
-(* This must be the position of the second last block of the file *)
-                download_first 0 (nblocks-2);
-
-(* These can be the positions of the second block of the file *)
-                download_first 0 1;
-                download_first (up.up_ncomplete-1) 1;
-                download_first (up.up_ncomplete-2) 1;
-
-(************* If the file can be verified, and we don't have a lot of blocks
-    yet, try to download the partial ones as soon as possible *)
-
-                if debug_all then lprintf_nl "{PartialBlock}";
-
-                let download_partial max_uploaders =
-                  let partial_block = ref (-1) in
-                  let partial_remaining = ref zero in
-                  for i = 0 to up.up_ncomplete - 1 do
-                    let n = up.up_complete_blocks.(i) in
-                    match s.s_blocks.(n) with
-                      PartialBlock b ->
-                        if (!partial_block = -1 ||
-                            !partial_remaining > b.block_remaining) &&
-                          s.s_nuploading.(n) < max_uploaders
-                        then
-                          begin
-                            partial_block := i;
-                            partial_remaining := b.block_remaining
-                          end
-                    | _ -> ()
-                  done;
-                  if !partial_block <> -1 then
-                    raise (BlockFound !partial_block)
-                in
-
-                if t.t_verifier <> NoVerification &&
-                  t.t_nverified_blocks  < 2  then begin
-                    download_partial max_nuploaders;
-                  end;
-
-(************* Download partial chunks from the verification point of view *)
-
-                if List.length s.s_networks > 1 then begin
-                    if debug_all then lprintf_n "{PartialChunk}";
-
-                    let my_t = if t.t_verifier <> NoVerification then t
-                      else match s.s_networks with t :: _ -> t | _ -> t in
-
-                    let download_partial max_uploaders =
-                      let partial_block = ref (-1) in
-                      let partial_remaining = ref 0 in
-                      for i = 0 to up.up_ncomplete - 1 do
-                        let n = up.up_complete_blocks.(i) in
-(* TODO move this after the first if... *)
-                        let t_index = t.t_chunk_of_block.(n) in
-                        let bs = List.filter (fun s_index ->
-                              s.s_verified_bitmap.[s_index] = '2'
-                          ) t.t_blocks_of_chunk.(t_index) in
-                        let nbs = List.length bs in
-
-(* TODO remove this *)
-                        let b = should_download_block s n in
-
-                        if !verbose_swarming then
-                            lprintf_nl "  test %d %c %d %b %d"
-                              n s.s_verified_bitmap.[n] s.s_nuploading.(n)
-                            b nbs;
-
-                        if s.s_verified_bitmap.[n] < '2' &&
-                          s.s_nuploading.(n) < max_uploaders &&
-                          should_download_block s n then
-
-                          if (!partial_block = -1 || !partial_remaining < nbs)
-                          then
-                            begin
-                              partial_block := i;
-                              partial_remaining := nbs
-                            end
-                      done;
-                      if !partial_block <> -1 then begin
-                          if !verbose_swarming then
-                            lprintf_n "PartialChunk won for %d waiting blocks"
-                              !partial_remaining;
-                          raise (BlockFound !partial_block)
-                        end
-                    in
-
-                    if my_t.t_verifier <> NoVerification then begin
-                        download_partial max_nuploaders;
-                      end;
-                  end;
-
-(************* Download rarest first only if other blocks are much more
-  available *)
-
-                if debug_all then lprintf "{Rarest}";
-
-                let sum_availability = ref 0 in
-                let min_availability = ref max_int in
-                for i = 0 to up.up_ncomplete - 1 do
-                  let n = up.up_complete_blocks.(i) in
-                  sum_availability := !sum_availability +
-                    s.s_availability.(n);
-                  min_availability := min !min_availability
-                    s.s_availability.(n);
-                done;
-
-                let mean_availability =
-                  !sum_availability / up.up_ncomplete in
-
-                if mean_availability > 5 && !min_availability < 3 then
-                  for i = 0 to up.up_ncomplete - 1 do
-                    let n = up.up_complete_blocks.(i) in
-                    if s.s_availability.(n) < 3
-                        && should_download_block s n
-                    then
-                      raise (BlockFound i)
-                  done;
-
-(************* Otherwise, download in random order *)
-
-                if debug_all then lprintf "{Random}";
-                let find_random max_uploaders =
-                  let list = ref [] in
-                  if debug_all then lprintf " {NC: %d}" up.up_ncomplete;
-                  for i = 0 to up.up_ncomplete - 1 do
-                    let n = up.up_complete_blocks.(i) in
-                    if s.s_nuploading.(n) < max_uploaders
-                        && should_download_block s n
-                    then
-                      list := i :: !list
-                  done;
-                  match !list with
-                    [] -> ()
-                  | [i] -> raise (BlockFound i)
-                  | list ->
-                      let array = Array.of_list list in
-                      raise (BlockFound (array.(
-                            random_int (Array.length array))))
-                in
-
-                find_random max_nuploaders
-
-(************* Fall back on linear download if nothing worked *)
-
-              in
-              iter_max_uploaders !!sources_per_chunk;
-              iter_max_uploaders max_int;
-              raise Not_found
-            with
-              BlockFound n ->
-                if debug_all then lprintf "\nBlockFound %d\n"
-                    up.up_complete_blocks.(n);
-                permute_and_return up n
-          end else
-          LinearStrategy.select_block up
+(* to evaluate the relative rarity of a block, we must compare it to
+   the availability of *all* blocks, not only those available from
+   that uploader *)
+	let sum_availability = Array.fold_left (+) 0 s.s_availability in
+	let mean_availability = sum_availability / Array.length s.s_blocks in
+
+	let my_t = if t.t_verifier <> NoVerification then t else 
+	  match s.s_networks with
+	    | tprim :: _ ->
+		assert(tprim.t_primary);
+		tprim
+	    | [] -> assert false in
+	let verification_available = my_t.t_verifier <> NoVerification in
+
+	let several_frontends = List.length s.s_networks > 1 in
+	(* many results may not be useful, evaluate them as needed *)
+	let completed_blocks_in_chunk = 
+	  Array.init my_t.t_nchunks (fun i ->
+            lazy (
+              List.fold_left (fun acc b ->
+		if s.s_verified_bitmap.[b] = '2' then acc + 1 else acc
+              ) 0 my_t.t_blocks_of_chunk.(i))) in
+
+	let preview_beginning = 10000000L in
+	let preview_end = (s.s_size ** 98L) // 100L in
+
+	(* sources_per_chunk was initially for edonkey only *)
+	let data_per_source = 9728000L // (Int64.of_int !!sources_per_chunk) in
+	
+	let need_to_complete_some_blocks_quickly = true
+	  (* verification_available && t.t_nverified_chunks < 2 *) in
+
+	(** > 0 == c1 is best, < 0 = c2 is best, 0 == they're equivalent *)
+	let compare_choices c1 c2 =
+
+	  (* avoid overly unbalanced situations *)
+	  let cmp = 
+	    if c1.choice_remaining_per_uploader < data_per_source ||
+	      c2.choice_remaining_per_uploader < data_per_source then
+		compare c1.choice_remaining_per_uploader 
+		  c2.choice_remaining_per_uploader else 0 in
+	  if cmp <> 0 then begin
+	    incr compare_choices_saturation;
+	    cmp 
+	  end else
+
+	  (* Do what Master asked for *)
+	  let cmp = compare c1.choice_user_priority c2.choice_user_priority in
+	  if cmp <> 0 then begin
+	    incr compare_choices_priority;
+	    cmp 
+	  end else
+
+	  (* Pick really rare gems: if average availability of all
+	     blocks is higher than 5 connected sources, pick in
+	     priority blocks present in at most 3 connected sources;
+	     is that too restrictive ? *)
+	  let cmp = 
+	    if not need_to_complete_some_blocks_quickly && 
+	      mean_availability > 5 &&
+	      (c1.choice_availability <= 3 || c2.choice_availability <= 3) then
+		compare c2.choice_availability c1.choice_availability 
+	    else 0 in
+	  if cmp <> 0 then begin
+	    incr compare_choices_rarity;
+	    cmp 
+	  end else
+
+	  (* try to quickly complete blocks *)
+	  let cmp = 
+	    compare c2.choice_remaining c1.choice_remaining in
+	  if cmp <> 0 then begin 
+	    incr compare_choices_completion;
+	    cmp 
+	  end else
+
+	  (* try to quickly complete (and validate) chunks; 
+	     if there's only one frontend, each chunk has only one
+	     block, and looking at siblings make no sense *)
+	  let cmp = 
+	    if verification_available && several_frontends then 
+	      compare (Lazy.force c1.choice_other_complete)
+		(Lazy.force c2.choice_other_complete)
+	    else 0 in
+	  if cmp <> 0 then begin
+	    incr compare_choices_siblings;
+	    cmp 
+	  end else
+
+	  begin
+	    (* Can't tell *)
+	    incr compare_choices_failure;
+	    0 
+	  end in
+
+	let best_choices, specimen = 
+	  subarray_fold_lefti (fun ((best_choices, specimen) as acc) n b ->
+	  (* priority bitmap <> 0 here ? *)
+	  if not (should_download_block s b) then acc else
+	    let nchunk = my_t.t_chunk_of_block.(b) in
+	    let block_begin = compute_block_begin s b in
+	    let block_end = compute_block_end s b in
+	    let size = block_end -- block_begin in
+	    let remaining = match s.s_blocks.(b) with
+		| EmptyBlock -> size
+		| PartialBlock b -> b.block_remaining
+		| CompleteBlock | VerifiedBlock -> 0L in
+	    let nuploaders = s.s_nuploading.(b) in
+	    let this_choice = {
+	      choice_num = n;
+	      choice_user_priority = (* priority bitmap here instead ? *)
+		if block_begin < preview_beginning then 3 else
+		  if block_end > preview_end then 2 else 1;
+	      choice_nuploaders = nuploaders;
+	      choice_remaining = remaining;
+	      choice_remaining_per_uploader = remaining //
+		(Int64.of_int (nuploaders + 1)); (* planned value *)
+	      choice_other_complete = completed_blocks_in_chunk.(nchunk);
+	      choice_availability = s.s_availability.(b);
+	    } in
+	    match best_choices with
+	    | [] -> [n], this_choice
+	    | _ :: _ ->
+		(* all the choices in the accumulator are supposed to
+		   be equivalent, compare against the specimen *)
+		let cmp = compare_choices this_choice specimen in
+		if cmp > 0 then [n], this_choice
+		else if cmp < 0 then acc
+		else n :: best_choices, specimen
+	  ) ([], dummy_choice) up.up_complete_blocks 0 (up.up_ncomplete - 1) in
+	(* what about up_partial_blocks ? 
+	   currently they're taken care of by linear_select_block
+	   fallback below *)
+
+	if debug_all then begin
+	  let nbest_choices = List.length best_choices in
+	  lprintf_nl "compare_choices: %d choices left based on saturation:%d priority:%d rarity:%d completion:%d siblings:%d failed:%d"
+	    nbest_choices
+	    !compare_choices_saturation !compare_choices_priority
+	    !compare_choices_rarity !compare_choices_completion
+	    !compare_choices_siblings !compare_choices_failure;
+	  let print_choice c =
+	    lprintf_nl "selected %d:%d priority:%d nup:%d rem:%Ld rpu:%Ld sib:%s av:%d" 
+	      c.choice_num up.up_complete_blocks.(c.choice_num)
+	      c.choice_user_priority 
+	      c.choice_nuploaders 
+	      c.choice_remaining 
+	      c.choice_remaining_per_uploader
+	      (if Lazy.lazy_is_val c.choice_other_complete then
+		string_of_int (Lazy.force c.choice_other_complete) else "?") 
+	      c.choice_availability in
+	  print_choice specimen
+	end;
+
+	try
+	  let n = 
+	    match best_choices with
+	      | [] -> raise Not_found
+	      | [choice] -> choice
+	      | _::_ -> 
+		  let nchoices = List.length best_choices in
+		  List.nth best_choices (Random.int nchoices) in
+
+          if debug_all then lprintf_nl "\nBlockFound %d"
+            up.up_complete_blocks.(n);
+          permute_and_return up n
+	with Not_found ->
+	  if !verbose_swarming then
+	    lprintf_nl "select_block: fallback to linear strategy";
+	  linear_select_block up
   with Not_found ->
 
       (* print_s "NO BLOCK FOUND" s; *)
-      raise Not_found
+    raise Not_found
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         find_block                                    *)
-(*                                                                       *)
-(*************************************************************************)
+(** If uploader is associated to a file being downloaded,
+    clear previously selected block (in any) and select best available
+    block, according to block selection strategy 
+    @param up the uploader *)
 
 let find_block up =
   try
     if debug_all then begin
-        lprintf "C: ";
-        for i = 0 to up.up_ncomplete - 1 do
-          lprintf "%d " up.up_complete_blocks.(i)
-        done;
-      end;
+      lprintf "C: ";
+      for i = 0 to up.up_ncomplete - 1 do
+        lprintf "%d " up.up_complete_blocks.(i)
+      done;
+    end;
 
     let t = up.up_t in
     let s = t.t_s in
     match file_state t.t_file with
     | FilePaused
     | FileAborted _
-    | FileCancelled -> raise Not_found
-    | _ ->
-
-
+    | FileCancelled 
+    | FileShared
+    | FileNew 
+    | FileDownloaded -> 
+	raise Not_found
+    | FileDownloading
+    | FileQueued ->
         (match up.up_block with
-            None -> ()
-          | Some b ->
-              let num = b.block_num in
-              s.s_nuploading.(num) <- s.s_nuploading.(num) - 1;
-              up.up_block <- None;
+	 | None -> ()
+         | Some b ->
+             let num = b.block_num in
+             s.s_nuploading.(num) <- s.s_nuploading.(num) - 1;
+             up.up_block <- None;
         );
 
-        let (b,block_begin,block_end) (* as result *) = select_block up in
+        let b, block_begin, block_end = select_block up in
         let num = b.block_num in
         s.s_nuploading.(num) <- s.s_nuploading.(num) + 1;
         up.up_block <- Some b;
@@ -2181,60 +2160,33 @@
         if debug_all then lprintf " = %d \n" num;
         b
   with e ->
-      if debug_all then lprintf_nl "Exception %s" (Printexc2.to_string e);
-      raise e
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         clean_ranges (internal)                       *)
-(*                                                                       *)
-(*************************************************************************)
+    if debug_all then lprintf_nl "Exception %s" (Printexc2.to_string e);
+    raise e
 
-let clean_ranges up =
+(** Remove completed ranges from an uploader's range list, and
+    decrease their reference counter *)
 
-  let rec iter list left =
-    match list with
-      [] -> List.rev left
-    | ((_,_,r) as rr) :: tail ->
-        iter tail
-          (if r.range_current_begin < r.range_end then rr :: left
-          else begin
-              r.range_nuploading <- r.range_nuploading - 1;
-              left
-            end)
-  in
-  up.up_ranges <- iter up.up_ranges []
+let remove_completed_uploader_ranges up =
+  let not_completed_ranges, completed_ranges = 
+    List.partition (fun (_,_,r) -> 
+      r.range_begin < r.range_end) up.up_ranges in
+  up.up_ranges <- not_completed_ranges;
+  List.iter (fun (_,_,r) -> 
+    r.range_nuploading <- r.range_nuploading - 1) completed_ranges
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         current_ranges                                *)
-(*                                                                       *)
-(*************************************************************************)
+(** uploader accessors *)
 
 let current_ranges up =  up.up_ranges
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         current_block                                 *)
-(*                                                                       *)
-(*************************************************************************)
-
 let current_block up =
   match up.up_block with
-    None -> raise Not_found
+  | None -> raise Not_found
   | Some b -> b
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         in_uploader_ranges                            *)
-(*                                                                       *)
-(*************************************************************************)
+(** Check whether a range is in a list *)
 
-let rec in_uploader_ranges r list =
-  match list with
-    [] -> false
-  | (_,_,r') :: tail when r' == r -> true
-  | _ :: tail -> in_uploader_ranges r tail
+let in_uploader_ranges r list =
+  List.exists (fun (_,_,r') -> r' == r) list
 
 (*************************************************************************)
 (*                                                                       *)
